package com.jkcredit.query.record.action;

import com.jkcredit.query.record.model.CommonResponseObject;
import com.jkcredit.query.record.service.QueryRecordService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author xusonglin
 * @version V1.0
 **/
@RestController
@RequestMapping("/api")
public class QueryRecordAction {
    @Autowired
    QueryRecordService queryRecordService;

    @PostMapping("/monthRecords")
    public CommonResponseObject monthRecords(@RequestParam String plateNumber, @RequestParam String month) {
        return queryRecordService.monthRecords(plateNumber, month);
    }

    @PostMapping("/yearRecords")
    public CommonResponseObject yearRecords(@RequestParam String plateNumber) {
        return queryRecordService.yearRecords(plateNumber);
    }

    @PostMapping("/count")
    public CommonResponseObject countByMonth(@RequestParam String month) {
        return queryRecordService.countByMonth(month);
    }

    @PostMapping("/multipleMonthRecords")
    public CommonResponseObject multipleMonthRecords(@RequestParam String plateNumber, @RequestParam String startMonth, @RequestParam String endMonth) {
        return queryRecordService.multipleMonthRecords(plateNumber, startMonth, endMonth);
    }
}
